!
! Use MPI reduction operations to perform scans
!

program collcomms

  use mpi

  implicit none

  integer :: comm, ierr, rank, size, request
  integer :: send_status(MPI_STATUS_SIZE), recv_status(MPI_STATUS_SIZE)
  integer :: sum, i, passon

  comm = MPI_COMM_WORLD

  call MPI_Init(ierr)
  call MPI_Comm_rank(comm,rank,ierr)
  call MPI_Comm_size(comm,size,ierr)

  sum = 0

  ! Initialise local values to:
  passon = rank
  ! Alternatively use
  ! passon = (rank+1)**2

  ! Use collective operation to perform scan

  call MPI_Scan(passon,sum,1,MPI_INTEGER,MPI_SUM,comm,ierr)

  write(*,*) "Using scan, the sum on rank ", rank, " is ", sum

  call MPI_Finalize(ierr)

end program collcomms
